'From Squeak2.8alpha of 4 February 2000 [latest update: #2158] on 20 May 2000 at 6:41:11 pm'!
"Change Set:		079WorldBackground-bf
Date:			14 May 2000
Author:			Bert Freudenberg

Makes bitmap backgrounds work again (reported by Raymond Asselin). Also translucent colors and gradients work, they're blended with black."!


!Morph methodsFor: 'e-toy support' stamp: 'bf 5/14/2000 22:16'!
makeGraphPaperGrid: smallGrid background: backColor line: lineColor

	| bigGrid gridForm |
	bigGrid _ 40 roundTo: smallGrid.
	gridForm _ Form extent: bigGrid asPoint depth: Display depth.
	gridForm fillWithColor: backColor.
	0 to: bigGrid by: smallGrid do: [:i |
		gridForm fill: (i@0 extent: 1@bigGrid) fillColor: lineColor.
		gridForm fill: (0@i extent: bigGrid@1) fillColor: lineColor].
	self color: (InfiniteForm with: gridForm).
	self world ifNotNil: [self world fullRepaintNeeded].
	self changed: #newColor.  "propagate to view"
! !

!Morph methodsFor: 'visual properties' stamp: 'bf 5/14/2000 22:33'!
useGradientFill
	"Make receiver use a solid fill style (e.g., a simple color)"
	| fill color1 color2 |
	self fillStyle isGradientFill ifTrue:[^self]. "Already done"
	color1 _ self color dominantColor.
	color2 _ color1 negated.
	fill _ GradientFillStyle ramp: {0.0 -> color1. 1.0 -> color2}.
	fill origin: self topLeft.
	fill direction: 0 @ self bounds extent y.
	fill normal: self bounds extent x @ 0.
	fill radial: false.
	self fillStyle: fill.! !


!PasteUpMorph methodsFor: 'display' stamp: 'bf 5/14/2000 22:28'!
pseudoDraw: aRectangle on: aCanvas
	| c f |
	c _ aCanvas copyClipRect: aRectangle.
	f _ self fillStyle.
	f isTranslucent ifTrue: [c fillColor: Color black].
	c fillRectangle: bounds fillStyle: f.
	turtleTrailsForm ifNotNil: [c paintImage: turtleTrailsForm at: 0@0].
	^c! !

